<!DOCTYPE html>
<html>

<head>
  <title>Tạo đơn hàng</title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1>Create Order </h1> </div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <select id="select-combo" class="form-control">
              <option value ="none">Chọn cỡ Combo (Combo size)</option>
              <option value="S">Nhỏ</option>
              <option value="M">Vừa</option>
              <option value="L">Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <select id="select-drink" class="form-control">
              <option value ="none">Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input id="input-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <select id="select-pizza" class="form-control">
              <option value ="none">Chọn loại pizza </option>
              <option value ="Seafood">Hải sản</option>
              <option value ="Hawaii">Hawaii</option>
              <option value ="Bacon">Thịt hun khói</option>
            </select>
          </div>        
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <input id="input-name" type="text" class="form-control" placeholder="Họ và tên"> 
          </div>
          <label for="" class="col-sm-2 col-form-label">Email <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <input id="input-email" type="email" class="form-control" placeholder="Email"> 
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <input id="input-phone" type="text" class="form-control" placeholder="Số điện thoại">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ <span class="text-danger">(*)</span></label>
          <div class="col-sm-4">
            <input id="input-address" type="text" class="form-control" placeholder="Địa chỉ"> 
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea id="input-message" class="form-control h-75" placeholder="Lời nhắn"></textarea>
        </div> 
        <div class="form-group">
          <button id="btn-create-order" class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
          <button id="btn-show-order" class="btn btn-secondary" onclick="onBtnShowOrderClick(this)">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_SUCCESS = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select drink
      loadDataDrinkList();
    }

    // function xử lý dữ liệu click button Create Order
    function onBtnCreateOrderClick() {
      // khai báo đối tượng chứa dữ liệu
      let vOrderObject = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai:"",
        diaChi: "",
        loiNhan: ""
      }
      // B1: Thu thập dữ liệu
      getOrderData(vOrderObject);
      console.log(vOrderObject);
      // B2: Validate dữ liệu
      let vDataValid = checkOrderData(vOrderObject);
      if (vDataValid) {
        // B3: Gọi API tạo order mới
        let vXmlHttpNewOrder = new XMLHttpRequest();
        callApiNewOrder(vOrderObject, vXmlHttpNewOrder);
        vXmlHttpNewOrder.onreadystatechange = function() {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) {
            // B4: Xử lý front-end
            console.log(vXmlHttpNewOrder.responseText);
            insertOrderCodeToBtnShowOrder(vXmlHttpNewOrder);
          }
        }
      }
    }
    
    // function xử lý dữ liệu click button Show Order
    function onBtnShowOrderClick(paramElement) {
      let vOrderCode = paramElement.dataset.ordercode;
      console.log("Order Code: " + vOrderCode);
      if (vOrderCode == undefined) {
        alert("Chưa tạo đơn hàng");
      }
      else {
        window.location.href = "Task25.40.order.detail.html?code=" + vOrderCode;
      }

    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
    }

    // function handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }

    // function thu thập dữ liệu
    // function trả về đối tượng chứa dữ liệu (paramOrder) được tham số hóa
    function getOrderData(paramOrder) {
      // truy vấn phần tử các thẻ input và select
      let vComboElement = document.getElementById("select-combo");
      let vDrinkElement = document.getElementById("select-drink");
      let vVoucherElement = document.getElementById("input-voucher");
      let vPizzaElement = document.getElementById("select-pizza");
      let vNameElement = document.getElementById("input-name");
      let vEmailelement = document.getElementById("input-email");
      let vPhoneElement = document.getElementById("input-phone");
      let vAddressElement = document.getElementById("input-address");
      let vMessageElement = document.getElementById("input-message");
      // gán giá trị cho đối tượng paramOrder
      // gán giá trị theo combo được chọn:
      paramOrder.kichCo = vComboElement.value;
      if (paramOrder.kichCo == "S") {
        paramOrder.duongKinh = 20,
        paramOrder.suon = 2,
        paramOrder.salad = 200,
        paramOrder.soLuongNuoc = 2,
        paramOrder.thanhTien = 150000
      }
      else if (paramOrder.kichCo == "M") {
        paramOrder.duongKinh = 25,
        paramOrder.suon = 4,
        paramOrder.salad = 300,
        paramOrder.soLuongNuoc = 3,
        paramOrder.thanhTien = 200000
      }
      else if (paramOrder.kichCo == "L") {
        paramOrder.duongKinh = 30,
        paramOrder.suon = 8,
        paramOrder.salad = 500,
        paramOrder.soLuongNuoc = 4,
        paramOrder.thanhTien = 250000
      }
      // gán giá trị cho các thuộc tính còn lại
      paramOrder.idLoaiNuocUong = vDrinkElement.value;
      paramOrder.idVourcher = vVoucherElement.value.trim();
      paramOrder.loaiPizza = vPizzaElement.value;
      paramOrder.hoTen = vNameElement.value.trim();
      paramOrder.email = vEmailelement.value.trim();
      paramOrder.soDienThoai = vPhoneElement.value.trim();
      paramOrder.diaChi = vAddressElement.value.trim();
      paramOrder.loiNhan = vMessageElement.value.trim();
    }
  
    // function validate dữ liệu
    // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
    function checkOrderData(paramOrder) {
      if (paramOrder.kichCo == "none") {
        alert("Vui lòng chọn kích cỡ combo");
        return false;
      }
      else if (paramOrder.idLoaiNuocUong == "none") {
        alert("Vui lòng chọn loại nước uống");
        return false;
      }
      else if (paramOrder.loaiPizza == "none") {
        alert("Vui lòng chọn loại pizza");
        return false;
      }
      else if (paramOrder.hoTen == "") {
        alert("Vui lòng nhập Họ và tên");
        return false;
      }
      else if (paramOrder.email == "") {
        alert("Vui lòng nhập Email");
        return false;
      }
      else if (paramOrder.soDienThoai == "") {
        alert("Vui lòng nhập Số điện thoại");
        return false;
      }
      else if (paramOrder.diaChi == "") {
        alert("Vui lòng nhập Địa chỉ");
        return false;
      }
      return true;
    }

    // function gọi API tạo order mới
    function callApiNewOrder(paramOrder, paramXmlHttp) {
      let vStringOrder = JSON.stringify(paramOrder);
      paramXmlHttp.open("POST", gBASE_URL, true);
      paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXmlHttp.send(vStringOrder);
    }

    // function gán orderCode vào button Show Order
    function insertOrderCodeToBtnShowOrder(paramXmlHttp) {
      let vOrderCode = JSON.parse(paramXmlHttp.responseText).orderCode;
      let vButtonShowOrder = document.getElementById("btn-show-order");
      vButtonShowOrder.setAttribute("data-ordercode", vOrderCode);
    }
  
  </script>

</body>

</html>